/*
 * SerializationTest.java
 *
 * Created on 07 December 2004, 17:02
 */

/**
 *
 * @author  Jean-Alain Grunchec
 */
package MiscTests;

import java.util.Vector;
import java.io.*;

//ByteBuffers
import java.nio.*;
import java.nio.channels.*;

public class SerializationTest
{
    static long start,end;

    OutputStream out = null;
    InputStream in = null;
    OutputStream outBuffer = null;
    InputStream inBuffer = null;
    ObjectOutputStream objectOut = null;
    ObjectInputStream objectIn = null;
    Person p = new Person("SID","austin");
    
    

    public static void main(String[] args){
             
             start = System.currentTimeMillis();
             SerializationTest st = new SerializationTest();
             for(int i=0;i<10000;i++){
                st.writeObject();
                st.readObject();
             }
             end = System.currentTimeMillis();
             System.out.println("Time taken for writing and reading :"+ (end-start) + "milli seconds");
    }
    public void readObject(){
        try{
//            in = new FileInputStream("c:/temp/test.txt");
            in = new ByteArrayInputStream(((ByteArrayOutputStream)out).toByteArray()); 
            inBuffer = new BufferedInputStream(in);
            objectIn = new ObjectInputStream(inBuffer);
            objectIn.readObject();
        }catch(Exception e){e.printStackTrace();}
        finally{
            if(objectIn != null)
            try{ objectIn.close();}catch(IOException e){e.printStackTrace();}
            }
    }

    public void writeObject(){
        try{
//out = new FileOutputStream("c:/temp/test.txt");            
            out = new ByteArrayOutputStream();
            outBuffer = new BufferedOutputStream(out);
            objectOut = new ObjectOutputStream(outBuffer);
            objectOut.writeObject(p);
        }catch(Exception e){e.printStackTrace();}
        finally{
            if(objectOut != null)
                try{ objectOut.close();}catch(IOException e){e.printStackTrace();}
        }
    }           

   
}

class Person implements java.io.Serializable
{
    static final String semicolon = new String(";");
    static ByteBuffer myBuffer = ByteBuffer.allocateDirect(400); 
    static final char chars[]=new char[50];
    static byte[] muche=new byte[400];
    static byte[] muche2=new byte[400];
    protected String name_1;
    protected String name_2;
    protected String name_3;
    protected String name_4;
    protected String name_5;
    protected String name_6;
    protected String name_7;
    protected String name_8;
    protected String name_9;
    protected String name_10;
    protected String name_11;
    protected String name_12;
    protected String name_13;
    protected String name_14;
    protected String name_15;
    protected String name_16;
    protected String name_17;
    protected String name_18;
    protected String name_19;
    protected String name_20;
   // protected Vector data;
   // protected String address;
    
    public Person(){
       // data= new Vector(7000);
    }
    
    public void OutPut(){
        System.out.println(name_1 + " "+ name_2);
    }
    
    public Person(String name,String address){
        this.name_1 = new String(name);
        this.name_2 = new String(name);
        this.name_3 = new String(name);
        this.name_4 = new String(name);
        this.name_5 = new String(name);
        this.name_6 = new String(name);
        this.name_7 = new String(name);
        this.name_8 = new String(name);
        this.name_9 = new String(name);
        this.name_10 = new String(name);
        this.name_11 = new String(name);
        this.name_12 = new String(name);
        this.name_13 = new String(name);
        this.name_14 = new String(name);
        this.name_15 = new String(name);
        this.name_16 = new String(name);
        this.name_17 = new String(name);
        this.name_18 = new String(name);
        this.name_19 = new String(name);
        this.name_20 = new String(name);       
        
     //   this.address = address;
     //   data= new Vector(7000);
    }
   /* public String getAddress(){
        return address;
    }*/
    /*public Vector getData(){
        return data;   
    }*/
    public String getName(){
        return name_1;
    }
    /*public void setData(Vector data){
        this.data = data;
    }*/
    
   /* private void writeObject(java.io.ObjectOutputStream out) throws IOException{
        String str=new String(name_1+";"+name_2+";"+name_3+";"+name_4+";"+name_5+";"+name_6+";"+name_7+";"+name_8+";"+name_9+";"+name_10+";"+name_11+";"+name_12+";"+name_13+";"+name_14+";"+name_15+";"+name_16+";"+name_17+";"+name_18+";"+name_19+";"+name_20+";");//name+";"+address+";";           
        out.writeUTF(str);        
    }
    private void readObject(java.io.ObjectInputStream in) throws IOException, ClassNotFoundException{
        String str2=in.readUTF();
        String str[]=str2.split(";");
        name_1=str[0];
        name_2=str[1];
        name_3=str[2];
        name_4=str[3];
        name_5=str[4];
        name_6=str[5];
        name_7=str[6];
        name_8=str[7];
        name_9=str[8];
        name_10=str[9];
        name_11=str[10];
        name_12=str[11];
        name_13=str[12];
        name_14=str[13];
        name_15=str[14];
        name_16=str[15];
        name_17=str[16];
        name_18=str[17];
        name_19=str[18];
        name_20=str[19];        
    }
*/
    public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException {

        //
        in.read(muche);
        myBuffer.rewind();
        myBuffer.put(muche);
        myBuffer.rewind();
       // in.readObject()
        //myBuffer=in.readObject();
        DocList.readString(myBuffer, chars, name_1);
        DocList.readString(myBuffer, chars, name_2);        
        DocList.readString(myBuffer, chars, name_3);
        DocList.readString(myBuffer, chars, name_4);
        DocList.readString(myBuffer, chars, name_5);
        DocList.readString(myBuffer, chars, name_6);
        DocList.readString(myBuffer, chars, name_7);
        DocList.readString(myBuffer, chars, name_8);
        DocList.readString(myBuffer, chars, name_9);
        DocList.readString(myBuffer, chars, name_10);
        DocList.readString(myBuffer, chars, name_11);
        DocList.readString(myBuffer, chars, name_12);
        DocList.readString(myBuffer, chars, name_13);
        DocList.readString(myBuffer, chars, name_14);
        DocList.readString(myBuffer, chars, name_15);
        DocList.readString(myBuffer, chars, name_16);
        DocList.readString(myBuffer, chars, name_17);
        DocList.readString(myBuffer, chars, name_18);
        DocList.readString(myBuffer, chars, name_19);
        DocList.readString(myBuffer, chars, name_20);
        

        //name_20=DocList.readString(myBuffer, chars);       
        
        /*
        int k=0;
        byte i,j;
        in.read(muche);
        i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
       // name_1=new String(muche2);
        i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_2=new String(muche2);        
        i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_3=new String(muche2);
        i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_4=new String(muche2);        
                i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_5=new String(muche2);
                i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_6=new String(muche2);
                i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_7=new String(muche2);
                i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_8=new String(muche2);
                i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_9=new String(muche2);
                i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_10=new String(muche2);
                i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_11=new String(muche2);
                i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_12=new String(muche2);
                i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_13=new String(muche2);
        i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_14=new String(muche2);
        i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_15=new String(muche2);
        
        i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_16=new String(muche2);
        i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_17=new String(muche2);
        i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_18=new String(muche2);
        i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_19=new String(muche2);
        i=muche[k++];
        j=0;
        while(j<i){
            muche2[j++]=muche[k++];
        }
        //name_20=new String(muche2);*/
        
        
       
        
        
    /*    String str2=in.readLine();
        String str[]=str2.split(semicolon);
        name_1=str[0];
        name_2=str[1];
        name_3=str[2];
        name_4=str[3];
        name_5=str[4];
        name_6=str[5];
        name_7=str[6];
        name_8=str[7];
        name_9=str[8];
        name_10=str[9];
        name_11=str[10];
        name_12=str[11];
        name_13=str[12];
        name_14=str[13];
        name_15=str[14];
        name_16=str[15];
        name_17=str[16];
        name_18=str[17];
        name_19=str[18];
        name_20=str[19];*/
      
    }
 
    public void writeExternal(ObjectOutput out) throws IOException {
        myBuffer.rewind();
        
        DocList.writeString(myBuffer,name_1); 
        DocList.writeString(myBuffer,name_2); 
        DocList.writeString(myBuffer,name_3); 
        DocList.writeString(myBuffer,name_4); 
        DocList.writeString(myBuffer,name_5); 
        DocList.writeString(myBuffer,name_6); 
        DocList.writeString(myBuffer,name_7); 
        DocList.writeString(myBuffer,name_8); 
        DocList.writeString(myBuffer,name_9); 
        DocList.writeString(myBuffer,name_10); 
        DocList.writeString(myBuffer,name_11); 
        DocList.writeString(myBuffer,name_12); 
        DocList.writeString(myBuffer,name_13); 
        DocList.writeString(myBuffer,name_14); 
        DocList.writeString(myBuffer,name_15);        
        DocList.writeString(myBuffer,name_16);      
        DocList.writeString(myBuffer,name_17);      
        DocList.writeString(myBuffer,name_18);      
        DocList.writeString(myBuffer,name_19);                
        DocList.writeString(myBuffer,name_20); 
        
        myBuffer.wrap(muche);
        out.write(muche);
        /*int k=0;
        byte i,l;
        muche2=name_1.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }
        muche2=name_2.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }        
        muche2=name_3.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }                
        muche2=name_4.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }                    
        muche2=name_5.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }            
        muche2=name_6.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }            
        muche2=name_7.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }            
        muche2=name_8.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        } 
        muche2=name_9.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }
        muche2=name_10.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }
        muche2=name_11.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }
        muche2=name_12.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }
        muche2=name_13.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }
        muche2=name_14.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }
        muche2=name_15.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }
        muche2=name_16.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }
        muche2=name_17.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }
        muche2=name_18.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }
        muche2=name_19.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }
        muche2=name_20.getBytes();
        i=(byte)(muche2.length);
        muche[k++]=i;
        l=0;
        while(i!=0){
            muche[k++]=muche2[l++];
            i--;
        }
        out.write(muche);*/
        
        //out.writeObject(myBuffer);
        //out.writeObject(myBuffer);
        
        /*String str=new String(name_1+semicolon+name_2+semicolon+name_3+semicolon+name_4+semicolon+name_5+semicolon+name_6+semicolon+name_7+semicolon+name_8+semicolon+name_9+semicolon+name_10+semicolon+name_11+semicolon+name_12+semicolon+name_13+semicolon+name_14+semicolon+name_15+semicolon+name_16+semicolon+name_17+semicolon+name_18+semicolon+name_19+semicolon+name_20+semicolon);//name+";"+address+";";           
        out.writeBytes(str);*/
	
        
        /// char is 16 bits !!!!!!  Unicode
        /// standard encodeing : UTF8   ; 0-127    top bit - multi-byte char

        
        // writeString(out, name_1); .... writes int - length; writes characters.....
        // writeString(out, name_2);
        // writeString(out, name_3);
        // writeString(out, name_4);
        
        // ByteBuffer vs ByteChannel in java.nio.xxx
        // FileChannel out = FileOutputStream.getChannel();
        // out.write (ByteBuffer buf)
        // ByteBuffer = wrapper on byte[]
        // ByteBuffer.allocate(4096).
        
        // java.io.FileOutputStream fos = new FileOutputStream(....);
        
        //  new StringBuffer()   .append(name1).append(";").append(........).toString()
        
       
    }    
}
