package guikit;

import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.NumberFormat;

import neuroml.core.*;
import neuroml.util.*;
 
/** List editor
 */
public class EditListPanel extends EditSetPanel {
    
    neuroml.core.List thelist;
 
    /** Build the list panel
     */
    public EditListPanel(Namespace ns, ObjectNode node) {
	super(node); 
	//System.out.println("Edit list panel starting...");
	this.ns = ns;
	thelist = (neuroml.core.List)node.getContent();
	baseClass = thelist.getType();
	elements = thelist.getElements();
	makePanel(elements);
	//System.out.println("Edit list panel done.");
	theparent = thelist;
    }
 
    /** Update real object 
     */
    public void confirm() {
	node.setContent(thelist);
	thelist.setElements( elements ); 
    }  
}
