package guikit;

import java.lang.reflect.*;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.text.NumberFormat;

import neuroml.util.*;
import neuroml.core.*;


/** Framed Panel
 */
public class FramedPanel extends JFrame {
 
    /** Build the panel
     */
    public FramedPanel(String title, JPanel contents) {
	super(title);
	getContentPane().setLayout( new BoxLayout(getContentPane(),BoxLayout.Y_AXIS));
	getContentPane().add(contents);
	pack();
	setVisible(true);
    }

    /** Build the panel
     */
    public FramedPanel(String title, JScrollPane contents) { 
	super(title);
	getContentPane().add(contents);
	pack();
	setVisible(true);
    }
}
