package guikit;
 
import neuroml.sim.Editor;
import java.util.Hashtable;

/** Lookup table for which editor to use for which class
 */
public class SpecialEditors {

    static Hashtable editors = new Hashtable();
    static Environment env;
    
    public static void put(String classname, String eclassname) {
	editors.put(classname, eclassname);
    }
    public static Editor get(String classname) {
	String e = (String)editors.get( classname );
	Editor ret = null;
	if (e!=null) {
	    try { 
		Class c = Class.forName( e);
		Object o = c.newInstance();
		if (o instanceof Editor) ret = (Editor) o;
	    } catch (Exception ex) {}
	}

	return ret;
    }
    /** Set and get the global environment for editors */
    public static void setEnvironment( Environment e ) { env = e; }
    public static Environment getEnvironment(   ) { return env; }
}
