package neosim.iface;

/** Interface for finding out details about connections
 * @see Entity#queryOutputConnections 
 */
public class ConnectionQuery implements java.io.Serializable {
    /** Queries a connection. Derived versions can return extra
     * information, such as weights, names of input segments etc,
     * using the connectionId embedded in the connection.
     * @param e the entity to query
     * @param c the connection to query.
     * @return the response to the query
     */
    public Object query( Entity e, Connection c ) { return null; }
}
