/*
 * GUI_Maker.java
 *
 * Created on 01 June 2004, 14:50
 */

package neosim.implementation;
import neosim.iface.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

import neuroml.sim.run.*;
import neosim.util.loaders.nmllauncher.*;
import neosim.kernel.*;


/**
 *
 * @author  Jean-Alain Grunchec
 */

public class GUI_Maker extends JPanel implements PlusMinusPanel {
    static GUI_Maker last=null;
    PopulationTreeImpl myPopTree;
    protected BasicKernel kernel;
    public final static void reset(){
        last=null;
    }
    public final static JPanel getLast(){
        return last;
    }
    
    /** Creates a new instance of GUI_Maker */
    public GUI_Maker(Simulator sim) {
        super();
        reset();
        Object o=null;
        String Str;
	myPopTree=null;
        try{
            if(sim==null)
                return;
            o=((XML_Reader)sim).getKernel();
            kernel=((BasicKernel)o);
            o=kernel.getPopulationTree(null);
        }
        catch(Exception e){
            System.out.println("Error GUI_Maker JAG");
            return;
        }
        
        myPopTree=(PopulationTreeImpl)o;
    }
    
    public final PopulationBuilderImpl getPopulation(String str){
        PopulationBuilderImpl myPopToDisplay;
         Object o;
         int size=myPopTree.nodes.size();
         for(int i=0;i<size;i++){
             o=myPopTree.nodes.elementAt(i);
             if(o!=null&&(o instanceof neosim.implementation.PopulationBuilderImpl)){
                myPopToDisplay=(PopulationBuilderImpl)o;
                if(myPopToDisplay.getName().compareTo(str)==0)
                    return myPopToDisplay;
             }
         }
         return null;
    }   
    
    public void Close() {
    }
    
    public void Expand() {
    }
    
    public void Open() {
    }
    
    public void Reduce() {
    }
    
    public void Refresh() {
    }
    
}
