/*
 * DeadlockTracker.java
 *
 * Created on 19 May 2005, 13:17
 */

package neosim.kernel;
import java.util.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */


public class DeadlockTracker {
    static boolean debug=false;
    public static DeadlockTrackerKernel tracker=new DeadlockTrackerKernel();

    /** Creates a new instance of DeadlockTracker */
    public DeadlockTracker() {
    }
    
    public static synchronized final void LockDeadlockTracker(Object caller, Deadlock_Message e){
        if(debug){
            /*while(e!=null)
                try{
                    wait();
                }
                catch(Exception x){x.printStackTrace();}*/
            tracker.add(e,caller);

        }
    }
    public static synchronized final void UnLockDeadlockTracker(Deadlock_Message e){
        if(debug){
            if(e!=null)
                tracker.remove(e);        
         //   e=null;     
           // notifyAll();
        }            
    }    
}
