package neosim.kernel;

/** The interface from server to applet - used
 * by the RMI kernel
 */
public interface RmtApp extends java.rmi.Remote, Commandable, Queryable {
  void addRmt(int rid, String n, RmtApp obj) throws java.rmi.RemoteException;
  void doneRmt(int rid) throws java.rmi.RemoteException;
  void removeRmt(int rid) throws java.rmi.RemoteException;
  void SendArray(Object[] Array) throws java.rmi.RemoteException;
  void SendSpikesArray(byte[] Spikes) throws java.rmi.RemoteException;
  void signal() throws java.rmi.RemoteException;
//RMI Tests
  void startTests() throws java.rmi.RemoteException;  
  void call() throws java.rmi.RemoteException;
  void sendByte(byte[] array) throws java.rmi.RemoteException;
  byte[] receiveByte(byte size) throws java.rmi.RemoteException;
  void sendInt(int[] array) throws java.rmi.RemoteException;
  int[] receiveInt(byte size) throws java.rmi.RemoteException;  
  long sum(int[] array) throws java.rmi.RemoteException;
  long sum(byte[] array) throws java.rmi.RemoteException;    
}
