package neosim.kernel;
import neosim.iface.*;
import neosim.implementation.*;

/** The ScriptCallback class restarts the script reader in response to a query.
 */
public class ScriptCallback implements Callback {
    //   ScriptReaderImpl sr; // Don't want to move this about !!! 
    public ScriptCallback() { }
    public final void callback( Entity e, Object o ) {
	ScriptReaderImpl sr = SimSystem.getScriptReader();
	sr.restart(o);
    }
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException { 
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
    }
}
