package neosim.neuroml;

import neosim.implementation.*;
import neosim.iface.*;
import java.util.Vector;
import java.util.Hashtable;
import neuroml.sim.run.*;
import neuroml.sim.state.*;

/**
 * Neuroml converter
 * utility functions that allows Neosim to communicate with NeuroML modules
 * @author Paul Rogister
 * @date Aug 2001
 * @deprecated use NeosimEntityQuery instead
 */
public class NeosimEntityQueryOld extends EntityQuery {
    String queryName;
    
    public NeosimEntityQueryOld(String queryName){
	this.queryName = queryName;
    }

    /** Run generic neuroml query on neosim
     */
    public Object query(Entity e) { 
	RunnableCell rc = ((NeosimEntityImpl)e).getRunnableCell();
	RequestableState st = (RequestableState)rc.getState();
	return st.request(queryName);	
    }
}
