package neosim.perf;

import java.util.*;

/** Store the vector of TypeParams for a PerfMonitor 
 */
public final class Types {
    protected Vector types;
    public Types() { types = new Vector(); }
    public void add(TypeParam tp) { types.addElement(tp); }
    public int size() { return types.size(); }
    public TypeParam get(int i)  { return (TypeParam)types.elementAt(i); }
    public TypeParam find( String s ) {
	TypeParam found = null, curr;
	int foundi = 0, i=0;
	Enumeration e;
	for (e = types.elements(); e.hasMoreElements();) {
	    curr = (TypeParam)e.nextElement();
	    if(s.compareTo(curr.getTypename()) == 0) {
		found = curr;
	    }
	}
	return found;
    }    
    Vector getV() { return types; }
}
