
package neuroml.core;

/**
 * A probability density function for a normal distribution
 * specified by its mean and variance.
 */
public class NormalPDF extends PDF {
    public double mean;
    public double variance;

    public NormalPDF() {
	this("normal",0,1);
    }

    public NormalPDF(String rngName, double mean, double variance) { 
	super(rngName);
	this.mean = mean;
	this.variance = variance;
    }

}
