package neuroml.core;

/** 
 * Superclass for all self contained neuroml files
 */
public class Pkg extends Model {

    public Pkg() { super(); }   
    public Pkg(String name) { super(name); }


    /** A list of classes defined here
     * Used by the Namespace
     * @see neuroml.util.Namespace
     */
    public static String[] getClassList() { 
	String[] ret = {
	    "DValue",
	    "DValueParameter",
	    "DoubleArray",
	    "Extension",
	    "GammaPDF",
	    "IntArray",
	    "IntParameter",
	    "List",
	    "Log",
	    "LogEntry", 
	    "LoggedObject",
	    "Module",
	    "Model",
	    "ModuleRef", 
	    "NamedObject",
	    "NormalPDF",
	    "Orientation",
	    "PDF",
	    "Parameter",
            "PermanentSet",
	    "Pkg",
	    "RNG",
	    "RandomVariable",
	    "Ref",
	    "Set",
	    "SimpleParameter",
	    "StringArray",
	    "StringParameter",
	    "ToolInfo",
            "TreeRef",
	    "UniformPDF",
	    "Unit"
	};
	return ret;
    }
}





