package neuroml.core;

/* Information about a tool which can deal with (create/edit/run?) an object.
 * This information should be sufficient to launch the tool on the object
 * just using the info in the XML file.
 */
public class ToolInfo extends NamedObject {

    public String version = new String();

    /** URL of tool's .jar file or equivalent
     */
    public String toolLocation = new String();
}
