/*
 * ArrayFunction.java
 *
 * Created on 23 September 2004, 15:33
 */

package neuroml.model.I_Clamp;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public class ArrayFunction extends _Function{
    protected _Function Array[];
    double dt;
//    double PreviousValue=0.0d;
  //  boolean stable=false;
    /** Creates a new instance of ArrayFunction */
    public ArrayFunction(int k, double dt) {
        Array=new _Function[k];
        this.dt=dt;
    }
    public double getValue(double d){
        double i=Math.floor(d/dt);
        if(i>Array.length) {
           /* if(PreviousValue!=0)
               stable=false;
            else
               stable=true; */
            return 0.0;
        }
/*        double Current=Array[(int)i].getValue(d-i*dt);
        double diff=(PreviousValue-Current)*1000;
        if(diff<0||diff>2*PreviousValue)
            stable=false;
        else
            stable=true; 
        PreviousValue=Current;*/
        return Array[(int)i].getValue(d-i*dt);        //NeuronIndex*NbColumn+
    }
    
    public void setFunction(_Function stuff, int k){
        Array[k]=stuff;
    }
    public _Function getFunction(int k){
        return Array[k];
    }    
   /* public boolean advance(double dt){
        return stable;
    } */
}
