/*
 * CellIntensity.java
 *
 * Created on 30 September 2004, 16:07
 */

package neuroml.model.MeasurementTool;
import neuroml.sim.run.*;
import neuroml.util.module.*;
import neuroml.core.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public class CellIntensity extends MeasurementTool {
    
    /** Creates a new instance of CellIntensity */
    public CellIntensity() {
        super();        
    }
    
    public double getValue(RunnableCell myCell, double t) {
        return ((BasicRunnableCell)myCell).getTotalIntensity(t);        
    }
    public String toString(){
        String toAdd=new String();
        if(this.ToBeSent)
            toAdd=new String();
        else
            toAdd=new String("NOT_");
        
        return toAdd+"I_Tot";
    }    
    public String getXUnit(){
        return "Time(s)";
    }
    public String getYUnit(){
        return "Intensity(A)";
    }        
    
    public Object Clone() {
        return new CellIntensity();
    }
}
