/*
 * Synapse.java
 *
 * Created on 19 August 2004, 16:39
 */

package neuroml.model.Synapse_nml;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public interface Synapse {
    void setCurrent(SynapticCurrent Current);
    void advance(double dt);
    void handleSpike(double d, double dt);
    //essential only in learning Synapses but make things easier
    void CheckLearning(double t, double dt);
    double getSynapseIntensity();
}
