package neuroml.model.network;

import neuroml.core.*;

/** 
 * A specification of a connection to make between
 * two elements
 */
public class ProbeConnection extends Attachment {

    public ProbeConnection(){
	setName("");
	dest=null;
    }
 

    /** Delay on this connection
     */
    public DValue delay  = new DValue(1.0,"ms");

     public void copy(Connector pr){
        ProbeConnection prt=(ProbeConnection) pr;
        this.delay=new DValue(prt.delay.value,prt.delay.unit.getTargetName());
    }
    public String TypeName(){
        return new String("ProbeConnection_del_"+delay.value);
    }  
}
