package neuroml.model.network;

import neuroml.core.*;

/** The basic empty projection 
 */
public class Projection extends Connector {

    public Projection() {this("","","");}
    public Projection(String name) {this(name,"",""); }

    /** A utility constructor
     */
    public Projection(String name, 
		      String source, String dest) {
	super(name); 
        this.source = new TreeRef("RealPopulation");//ElementRef->Ref->TreeRef  
	this.dest = new TreeRef("RealPopulation");  //ElementRef->Ref->TreeRef 
        ((TreeRef)(this.source)).addLeaf("RealPopulation");
        ((TreeRef)(this.source)).addNode("SubNetwork");        
        ((TreeRef)(this.dest)).addLeaf("RealPopulation");
        ((TreeRef)(this.dest)).addNode("SubNetwork"); 
	(this.source).setTargetName(source);
	(this.dest).setTargetName(dest);
    }
}
