package neuroml.sim.run;  

import java.util.List;

/** A query interface for cells with synapses 
 */
public interface ConnectionsQueryable {
    /** Returns the collection of input connections
     * @param inPort the input port
     * @return the list of SynapseState objects
     */
    public List getInputConnections(int inPort);

    // Could also have getInputConnections(Filter f);
}
