package neuroml.sim.run;  

/** A query to send to an object.
 */
public interface Query {

    /** Returns the results of a query
     * Implementations of this perform any required query on an object.
     * @param o the object to query
     * @return the result of the query
     */
    public Object query(Object o);
}
