package neuroml.sim.state;

import neuroml.sim.run.*;

/** Interface to access the state of a cell instance
 */
public interface CellState extends ElementState {
    
    /** Return runnable cell */
    public RunnableCell getRunnableCell();

    /** Return flattened instantiated structure */
    //    public CellInstanceStructure getStructure();
}
