package neuroml.util.schema;

import neuroml.core.*; 
import neuroml.util.*; 

/** 
 * NeuromlSchema version of a "Package".
 * It has a name and a set of classes.
 * Currently imports / dependencies are not specified here.
 */
public class NeuromlPackage extends NamedObject {

    /** The set of URLs of schemas imported.
     */
    public Set imports = new Set("String");    

    /** The set of classes
     */
    public Set classes = new Set("neuroml.util.schema.NeuromlClass");

    public NeuromlPackage() { }
    public NeuromlPackage( String n ) { name = n; }
}

