/*
 * ExternalizedOptimalClass.java
 *
 * Created on 11 January 2005, 17:33
 */

package MiscTests;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public final class ExternalizedOptimalClass implements SerializedClass, java.io.Externalizable{
    byte[] byteArray;

    static    byte B0=0,B1=1,B2=2,B3=3,B4=4,B5=5,B6=6,B7=7;
    static    int I0=0,I1=1;
    static    long L0=0;
    static    String str=new String("Hello, world!");  
    /** Creates a new instance of ExternalizedOptimalClass */
    public ExternalizedOptimalClass(boolean truc) {
        byte B0=0,B1=1,B2=2,B3=3,B4=4,B5=5,B6=6,B7=7;
        int I0=0,I1=1;
        long L0=0;
        String str=new String("Hello, world!");        
        byte [] str_=str.getBytes();
        int size=8+8+8+str_.length;
        byteArray=new byte[size];
        byteArray[0]=B0;
        byteArray[1]=B1;
        byteArray[2]=B2;
        byteArray[3]=B3;
        byteArray[4]=B4;
        byteArray[5]=B5;
        byteArray[6]=B6;
        byteArray[7]=B7;
        byteArray[8]=(byte)((I0&0xFF000000)>>6);
        byteArray[9]=(byte)((I0&0x00FF0000)>>4);
        byteArray[10]=(byte)((I0&0x0000FF00)>>2);
        byteArray[11]=(byte)(I0&0x000000FF);
        byteArray[12]=(byte)((I1&0xFF000000)>>6);
        byteArray[13]=(byte)((I1&0x00FF0000)>>4);
        byteArray[14]=(byte)((I1&0x0000FF00)>>2);
        byteArray[15]=(byte)(I1&0x000000FF);        
          
        int temp=(int)L0>>8;
        byteArray[16]=(byte)((temp&0xFF000000)>>6);
        byteArray[17]=(byte)((temp&0x00FF0000)>>4);
        byteArray[18]=(byte)((temp&0x0000FF00)>>2);
        byteArray[19]=(byte)(temp&0x000000FF);
        byteArray[20]=(byte)((L0&0xFF000000)>>6);
        byteArray[21]=(byte)((L0&0x00FF0000)>>4);
        byteArray[22]=(byte)((L0&0x0000FF00)>>2);
        byteArray[23]=(byte)(L0&0x000000FF);    
        
        System.arraycopy(str_,0, byteArray, 24,str_.length);
        System.out.println("Size of ExternalizedOptimalClass array "+byteArray.length);
        
    }
    public ExternalizedOptimalClass(){
        
    }
    
    public void readExternal(java.io.ObjectInput objectInput) throws java.io.IOException, java.lang.ClassNotFoundException {
        byteArray=new byte[objectInput.readByte()];
        objectInput.read(byteArray);
    }
    
    public void writeExternal(java.io.ObjectOutput objectOutput) throws java.io.IOException {
        objectOutput.writeByte(byteArray.length);
        objectOutput.write(byteArray);
    }    
    public void compression(){
        for(int i=0;i<100000;i++){
      
        byte [] str_=str.getBytes();
        int size=8+8+8+str_.length;
        byteArray=new byte[size];
        byteArray[0]=B0;
        byteArray[1]=B1;
        byteArray[2]=B2;
        byteArray[3]=B3;
        byteArray[4]=B4;
        byteArray[5]=B5;
        byteArray[6]=B6;
        byteArray[7]=B7;
        byteArray[8]=(byte)((I0&0xFF000000)>>6);
        byteArray[9]=(byte)((I0&0x00FF0000)>>4);
        byteArray[10]=(byte)((I0&0x0000FF00)>>2);
        byteArray[11]=(byte)(I0&0x000000FF);
        byteArray[12]=(byte)((I1&0xFF000000)>>6);
        byteArray[13]=(byte)((I1&0x00FF0000)>>4);
        byteArray[14]=(byte)((I1&0x0000FF00)>>2);
        byteArray[15]=(byte)(I1&0x000000FF);        
          
        int temp=(int)L0>>8;
        byteArray[16]=(byte)((temp&0xFF000000)>>6);
        byteArray[17]=(byte)((temp&0x00FF0000)>>4);
        byteArray[18]=(byte)((temp&0x0000FF00)>>2);
        byteArray[19]=(byte)(temp&0x000000FF);
        byteArray[20]=(byte)((L0&0xFF000000)>>6);
        byteArray[21]=(byte)((L0&0x00FF0000)>>4);
        byteArray[22]=(byte)((L0&0x0000FF00)>>2);
        byteArray[23]=(byte)(L0&0x000000FF);    
        
        System.arraycopy(str_,0, byteArray, 24,str_.length);
        }
    }
    
}
