package MiscTests;

import java.net.*;
import java.io.*;

public class PingServer {
    public static void main(String[] args) throws IOException {

        ServerSocket serverSocket = null;
        try {
            serverSocket = new ServerSocket(4450);
        } catch (IOException e) {
            System.err.println("Could not listen on port: 4444.");
            System.exit(1);
        }

        Socket clientSocket = null;
        try {
	    System.out.println("Listening to client requests...");
            clientSocket = serverSocket.accept();
        } catch (IOException e) {
            System.err.println("Accept failed.");
            System.exit(1);
        }


	OutputStream os = clientSocket.getOutputStream();
        //PrintWriter out = new PrintWriter(clientSocket.getOutputStream(), true);
	InputStream is = clientSocket.getInputStream();
        //BufferedReader in = new BufferedReader(new InputStreamReader(is));
        String inputLine, outputLine;

	os.write(1); // ready.

	int sz = 3200;
	byte[] b = new byte[sz];
	int c = 0;
        while (true) {
	    int icnt = 0;
	    while (icnt < sz) {
		icnt += is.read(b, icnt, sz-icnt);
	    }

	    if (c==10000) {
		os.write(0); // done.
		break;
	    }
	    else {
		os.write(1); // ready.
	    }
	    c++;
        }
       // out.close();
        //in.close();
        clientSocket.close();
        serverSocket.close();
    }
}
