package guikit;

import javax.swing.*; 
import javax.swing.text.*; 

import java.awt.Toolkit;
import java.text.*;

public class DecimalField extends JTextField {

    public DecimalField(double value, int columns) {
        super(columns);
        setValue(value);
	setFont(GuiKit.getDefaultFont());
    }

    public double getValue() {
        double retVal = 0.0;
	try {
	    retVal = Double.valueOf(getText()).doubleValue();
	} catch (Exception e) {
	}
        return retVal;
    }

    public void setValue(double value) {
	Double valdb = new Double(value);
        setText(valdb.toString());
    }
    public void setValue(int value) {
        setText((new Integer(value)).toString());
    }
}
