/*
 * LinkProjection.java
 *
 * Created on 23 February 2004, 16:12
 */

package guikit;
import java.util.*;
import java.awt.*;
import neuroml.core.*;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public class LinkProjection {
    Connector myProj=null;
    NodePopulation Source;
    NodePopulation Target;
    Vector Path=new Vector(1,1);//Paths
    /** Creates a new instance of LinkProjection */
    public LinkProjection(Connector myProj, NodePopulation src,NodePopulation tgt) {
        this.myProj=myProj;
        Source=src;
        Target=tgt;
    }
    public void addPath(Dimension d)
    {
        Path.add(d);
    }
    public void display()
    {
        ((Link)(myProj.editorInfo)).redraw(Path, Source.getX(),Source.getY(),Target.getX(),Target.getY()) ;
    }
}
