/*
 * NetworksSubPanel.java
 *
 * Created on 22 April 2004, 17:14
 */

package guikit;
import guikit.*;
import neuroml.util.*;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import javax.swing.event.*;
import neuroml.model.network.*;
import neuroml.sim.*;
import neuroml.core.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public class NetworksPanel_General extends NotifyingSet  {
    /** Creates a new instance of NetworksSubPanel */
    public NetworksPanel_General(ObjectNode node,ElementChangedListener ecl) {
        super(node,ecl);
    }
    public NetworksPanel_General(Namespace ns, ObjectNode node,ElementChangedListener ecl) {
	super(ns,node,ecl);        
    }
   public void popupEditor(Namespace ns, ObjectNode ne, String base) {
        notifyParent.elementChanged("NetworksPanel_General", (Network)ne.getContent());
   }
    protected void SetDefaultSize(JComponent pane){
        pane.setMinimumSize( new Dimension(40,30) );
	pane.setPreferredSize( new Dimension(40,40) );
    }
    protected void popupEditor(int i,Object o) {
        Network n=null;
         if(i!=0) 
            i-=1;
         if(elements.size()!=0)
         {  
            Object ob = elements.elementAt(i);
            ObjectNode ne = new ObjectNode(theparent, ob, this);
            if (ob instanceof Nameable) { 
                ne.setPath( node.getPath(),((Nameable)ob).getName() );
            } else {
                ne.setPath( node.getPath(),baseClass+"_"+i );
            }
            n=(Network)ne.getContent();
         }
         notifyParent.elementChanged("NetworksPanel_General_Remove",n );         
    }    
    /** Listen to text field changes
     */   
}
