/*
 * NodePopulation.java
 *
 * Created on 23 February 2004, 16:10
 */

package guikit;
import java.awt.*;
import java.util.*;
import java.io.*;
//import neuroml.model.network.*;
import neuroml.core.*;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public class NodePopulation {
    double X;
    double Y;
    double Width;
    double Height;
    public Vector<NodePopulation> Neighbours=new Vector<NodePopulation>(1,1);
    String Name;
    //Population myPop=null;
    NamedObject myPop=null;
    
    
    /*
     * Creates a new instance of NodePopulation 
     */
    
    public NodePopulation(String Name,NamedObject myPop) {//Population
        this.Name=Name;
        this.myPop=myPop;
    }
    
    public String getName() {
        return Name;
    }
    
    public void Output(){
        String Buffer;
        try{
            FileWriter fos = new  FileWriter("Temp/" +getName()+".java");//was"\\"
            Buffer=new String("package Temp;\n");
            fos.write(Buffer);
            Buffer=new String("public class "+Name+"{ \n");
            fos.write(Buffer);
            for(int i=0;i<Neighbours.size();i++){
                NodePopulation tmp1=(NodePopulation)(Neighbours.elementAt(i));
                String tmp2=tmp1.getName();
                Buffer=new String("public "+ tmp2 +" var_" + tmp2 +"_"+i+";\n");
                fos.write(Buffer);
            }
            Buffer=new String("}");
            fos.write(Buffer);
            fos.close();
        }
        catch(Exception e){
        }
    }
    
    public void setX(double X){
        this.X=X;
    }
    
    public void setY(double Y){
        this.Y=Y;
    }
    
    public double getX(){
        return X;
    }
    
    public double getY(){
        return Y;
    }
    
    public void setHeight(double Height){
        this.Height=Height;
    }
    
    public void setWidth(double Width){
        this.Width=Width;
    }
    
    public void display()
    {
        X+=Width*0.5;
        Y+=Height*0.5;
        ((Node)(myPop.editorInfo)).cx=X;
        ((Node)(myPop.editorInfo)).cy=Y;
        ((Node)(myPop.editorInfo)).xsize=Width;
        ((Node)(myPop.editorInfo)).ysize=Height;
    }
}
