/*
 * NotifyingSet.java
 *
 * Created on 05 May 2004, 18:28
 */

package guikit;
import guikit.*;
import java.awt.*;
import javax.swing.*;
import neuroml.sim.*;
import neuroml.util.Namespace;
import neuroml.model.cell.AbstractNeuron;
import javax.swing.event.*;
import java.awt.event.*;

/**
 *
 * @author  Jean-Alain Grunchec
 */
public class NotifyingSet extends EditSetPanel {
    protected ElementChangedListener notifyParent;
    
    public NotifyingSet(ObjectNode node,ElementChangedListener ecl) {
        super(node);
        notifyParent=ecl;
    }
    public NotifyingSet(Namespace ns, ObjectNode node,ElementChangedListener ecl) {
	super(ns,node);
        notifyParent=ecl;        
    }    
    public void popupEditor(Namespace ns, ObjectNode ne, String base) {
        Editor specialEditor = SpecialEditors.get( ne.getContent().getClass().getName() );
        notifyParent.elementChanged(ne.getContent(), ne.getContent());
	if (specialEditor==null) {

            if(notifyParent instanceof SubnetsEditor_StandAlone){
                /*
                 * eop = new EditObjectPanel( ns, ne, base , true,true,this);                                                       
	    eop.addElementChangedListener(this);
            JPanel PanelEdit=new JPanel(new BorderLayout()); 
            int v=ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED;
            int h=ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED;     
            JScrollPane jsp = new JScrollPane(eop,v,h);
            PanelEdit.add(jsp,BorderLayout.CENTER);
            JPanel buttons = new JPanel();
            buttons.setLayout( new BoxLayout(buttons, BoxLayout.X_AXIS) );
            String stuff=new String();
            buttons.add(eop.makeButton("Remove", "remove", this));
            buttons.add(eop.makeButton("Save "+ns.getShortClassName(ne.getName()), "save", eop));
            buttons.add(eop.makeButton("Close", "close", this));
            PanelEdit.add(buttons,BorderLayout.SOUTH);
            superParent.DisplaySide(PanelEdit);
                 */
             EditObjectPanel eop = new EditObjectPanel( ns, ne,  baseClass, true,true);
            //eop.addElementChangedListener(notifyParent); //Commemted becouse of renaming of reference->CTD
            JPanel PanelEdit=new JPanel(new BorderLayout()); 
            int v=ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED;
            int h=ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED;     
            JScrollPane jsp = new JScrollPane(eop,v,h);
            PanelEdit.add(jsp,BorderLayout.CENTER);
            JPanel buttons = new JPanel();
            buttons.setLayout( new BorderLayout() );
            String stuff=new String();
           /* buttons.add(eop.makeButton("Remove", "remove", new ActionListener()
		{	public void actionPerformed(ActionEvent e)
			{
				//numlines = 0;
				//repaint();
			}
		} 
                ));*/
            final Object obj0=ne.getContent();
            buttons.add(eop.makeButton("Save "+ns.getShortClassName(ne.getName()), "save", eop),BorderLayout.WEST);
            buttons.add(eop.makeButton("Close", "close", new ActionListener()
		{	public void actionPerformed(ActionEvent e)
			{
				 ((SubnetsEditor_StandAlone)notifyParent).HideSide();
                                 notifyParent.elementChanged(obj0, obj0);
			}
		} 
                ),BorderLayout.EAST);

            PanelEdit.add(buttons,BorderLayout.SOUTH);            
            ((SubnetsEditor_StandAlone)notifyParent).DisplaySide(PanelEdit);
                
            }
            else{
	    EditObjectPanel eop = new EditObjectPanel( ns, ne, 
						       baseClass,
						       false,true );
            eop.addElementChangedListener(notifyParent);                
                eop.popup();
            }
           // notifyParent.elementChanged(ne.getContent(), ne.getContent());
            
            
            //dialog.show();
        }	    
	 else {
	    specialEditor.editObject( ne.getContent(), ne.getPath(), this );
	}
    }
    protected String NameBorder(){
        return baseClass+"s";
    }
    protected void popupEditor(int i,Object o) {
          notifyParent.elementChanged(o, o);   
    }    
    
}
