package guikit;
 

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.image.*;

import java.util.Vector;
import java.util.StringTokenizer;
import java.util.Enumeration;

import javax.swing.*;

import neuroml.util.*;
import neuroml.core.*;
import neuroml.model.cell.*;
import neuroml.model.network.*;

import java.util.Random.*;
   


/** A serializable / editable colour
 * Needs a hint that we want a JColorChooser to edit it.
 */
public class RGBColour {
    /** Colour stored a string value  "#0000ff" 
     */
    static Random RndGen;  
    static int col=0;
    static int light=0;
    public String value;

    public RGBColour() { value="000000"; }
    public RGBColour(String v) { value=v; }
    public Color getColor() { 
	return new Color(Integer.parseInt(value,16)); 
    }
    public void setColor(Color c) { 
	value = Integer.toString(c.getRGB(), 16 );
    }
    static public void InitSeed(long mySeed)
    {
        RndGen=new Random(mySeed);
    }
    
    public void SetRandom()
    {
        Color c=new Color(0,0,0);
        switch(col)
        {
            case 0:{
                c=Color.BLUE;
            };break;
            case 1:{
                c=Color.CYAN;
            };break;
            case 2:{
                c=Color.GREEN;
            };break;            
            case 3:{
                c=Color.MAGENTA;
            };break;                     
            case 4:{
                c=Color.ORANGE;
            };break;                       
            case 5:{
                c=Color.YELLOW;
            };break;  
            case 6:{
                c=Color.RED;
                if(light<1)
                    light++;
                else 
                    light=0;
            };break;              
        }
        if(light==1)
            c=c.darker();
        if(col<6)
            col++;
        else
            col=0;
       
        value = Integer.toString(c.getRGB(),16);
        System.out.println(value);
    }
    // ToolInfo ... please use JColorChooser!!!  Not the default!!!
    // Serialize as colour
}
