/*
 * HHNeuronFactory.java
 *
 * Created on 26 August 2004, 13:43
 */

package Holger_modules.module.channels;
import neuroml.util.module.*;
import neuroml.sim.run.SpikeSender;
import neuroml.sim.state.PopulationState;
import neuroml.sim.run.RunnableCell;
import java.awt.*;
import java.awt.geom.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public class HHNeuronFactory extends neuroml.util.module.BasicChannelCellFactory {
    public int pointsPerCurve=100;
    /** Creates a new instance of HHNeuronFactory */
    public HHNeuronFactory() {
        super();
    }
    public RunnableCell makeRunnableCell(PopulationState populationstate, int id,int index, SpikeSender spikesender)
    {
        return new HHNeuron(this, populationstate, id,index, spikesender, InitialV);
    }
    public Color getColorSoma(){
        return new Color(1.0f,0.65f,0.0f);
    }    
    
    /*
     *  
     */
    
    public void DrawExtra(Graphics2D g, Object pop, double x, double y, double width, double height, String msg, boolean selected, Font f){
        super.DrawExtra(g,pop,x,y,width,height, msg,selected,f);
        g.setColor(Color.pink);
        g.fill(new Rectangle2D.Double(x-16-width*0.4,y-12, 20, 24));
        g.setStroke(new java.awt.BasicStroke(1));
        g.setColor(Color.blue.darker().darker());
        g.draw(new Line2D.Double(x-16-width*0.4,y+8,x-12-width*0.4,y+8));
        g.draw(new Line2D.Double(x-12-width*0.4,y+8,x-6-width*0.4,y));
        g.draw(new Line2D.Double(x-6-width*0.4,y-10,x-6-width*0.4,y+10));
        g.draw(new Line2D.Double(x-6-width*0.4,y+10,x+2-width*0.4,y+8)); 
        
        g.draw(new Line2D.Double(x-width*0.4-16,y-12,x-width*0.4+4,y-12));
        g.draw(new Line2D.Double(x-width*0.4-16,y-12,x-width*0.4-16,y+12));
        g.draw(new Line2D.Double(x-width*0.4+4,y+12,x-width*0.4+4,y-12));
        g.draw(new Line2D.Double(x-width*0.4+4,y+12,x-width*0.4-16,y+12));        
   }
}
