package neosim.iface;

/** An EntityQuery is the interface used for all
 * queries of an entity's state.
 * @see Entity Entity
 * @see ScriptReader ScriptReader
 */
public class EntityQuery implements java.io.Serializable {
    /** Queries an entity's state. Derived classes should override this
     * to perform the relevant query.
     * @param e the entity to query
     * @return the response to the query
     */
    public Object query( Entity e) { return new Integer(0); }
}
