/*
 * InPortTableOneOne.java
 *
 * Created on 03 February 2005, 15:36
 */

package neosim.kernel;
import neosim.iface.*;
import neosim.implementation.*;
import neosim.kernel.*;
import java.util.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public class InPortTableOneOne {
    int eid;
    int Array[];
    int nbConnections=0;
    LinkedListConnections buffer=new LinkedListConnections();
    /** Creates a new instance of InPortTableOneOne */
    public InPortTableOneOne() {
    }
    public void add(int dest, long time, int cid){
        buffer.add(dest, time, cid);
    }
    static public Vector getConnection(InPortTableOneOne[] table, int [] setConnections,EntityImpl e){
        int length=setConnections.length;
        int i=0;
        int temp;
        InPortTableOneOne truc;
        int CurrentIndex;
        Vector v=new Vector();
        while(i<length){
            temp=setConnections[i];
            CurrentIndex=3;
            truc=table[temp];
            while(temp==setConnections[i]){
                while(truc.Array[CurrentIndex]!=i){
                    CurrentIndex+=4;
                }
                long delay=(long)((truc.Array[CurrentIndex-2])<<32);
                delay|=(truc.Array[CurrentIndex-1]&0xFFFFFFFF);
                ConnectionImpl c=new ConnectionImpl(temp, (short)1, e, (short)1, delay );
                c.setConnectionID(i);
                v.add(c);
                i++;
            }
        }
        //NOT FINISHED JAG030205
        return null;
    }
    
    public void compress(){
        Array=buffer.compress();
        buffer=null;
        nbConnections=Array.length/4;
    }
    
    public boolean IsOneOne(){
        return true;
    }
    public final int getEid() { return eid; }
    public final short getPid() { return 1; }

    public final void sendEvent(Event ev) {      
       System.out.println(" InPortTableOneOne : send Events : I SHOULD NOT BE CALLED ");
    }

    public final void addSpike(long time, BasicKernel bk){
        //destent.addSpike(destcid,time+getDelay());
        int length=Array.length;
        int dest;
        long delay;
        int cid;
        for (int i=0; i<length; ) {
            dest=Array[i++];
            delay=Array[i++]<<32;
            delay|=Array[i++]&0xFFFFFFFF;
            cid=Array[i++];
            if(dest!=-1){
                bk.getLocalEntity(dest).addSpike(cid, time+delay);
            }
        }
        
    }
}

class LinkedListConnections{
      int RealIndex_read=0;
      static final int ListSize=50;
      static final int RealListSize=ListSize*4;
      LinkedListConnections next=null;
      int array[]=new int[RealListSize];//1 int for the dest and 2 ofr the time
      
      public LinkedListConnections(){
      }
      
      public void add(int dest, long time, int cid){
          if(RealIndex_read==RealListSize){
              if(next==null)
                next=new LinkedListConnections();
              next.add(dest, time, cid); 
          }
          else{
              array[RealIndex_read++]=dest;
              array[RealIndex_read++]=((int)(time>>32)&0xFFFFFFFF);
              array[RealIndex_read++]=(int)(time&0xFFFFFFFF);
              array[RealIndex_read++]=cid;
          }
      }
      
      public int[] compress(){
          LinkedListConnections temp=this;
          int Total=0;
          do{
              Total+=temp.RealIndex_read;
              temp=temp.next;
          }
          while(temp!=null);
          
          int array[]=new int[Total];
          
          temp=this;
          Total=0;
          do{
              System.arraycopy(temp.array, 0, array, Total, RealIndex_read);
              Total+=RealIndex_read;
              temp=temp.next;
          }
          while(temp!=null);          
          return array;
      }
}