package neosim.neuroml;

import neuroml.sim.state.*;
import neosim.iface.*;

/** Neuroml view of a neosim entity
 */
public final class NeuromlCellState implements ElementState {  

    neosim.iface.Entity en;

    public NeuromlCellState( neosim.iface.Entity e ) { en = e; }

    /** Set the global id of this element
     * @param id the globale id
     */
    public void setID(int id) {
	// for the moment, no setID method in iface.Entity
    }

    /** Return the global id of this element
     * @return the global id
     */
    public int getID() {
	return en.getID();
    }   
    
    
}
