
package neuroml.core;

/**
 * The superclass for probability density functions
 */
public class PDF {
    String name="";
    public Ref rngRef = new Ref("RNG");

    public PDF() { 
	this("DefaultRNG");
    }
    public PDF(String rngName) { 
	rngRef = new Ref("RNG");
	rngRef.setTargetName(rngName);
    }

    public String getName() { return name; }
    public void setName(String n) { name = n; }    
}
