/*
 * CellInternalIntensity.java
 *
 * Created on 30 September 2004, 16:07
 */

package neuroml.model.MeasurementTool;
import neuroml.sim.run.*;
import neuroml.util.module.*;
import neuroml.core.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public class CellInternalIntensity extends MeasurementTool {
 
    /** Creates a new instance of CellInternalIntensity */
    public CellInternalIntensity() {
        super();        
    }
    
    public double getValue(RunnableCell myCell, double t) {
        return ((BasicRunnableCell)myCell).getInternalIntensity(t);                
    }
    public String toString(){
        String toAdd;
        if(this.ToBeSent)
            toAdd=new String();
        else
            toAdd=new String("NOT_");
        return toAdd+"I_Int";
    }
    public String getXUnit(){
        return "Time(s)";
    }
    public String getYUnit(){
        return "Intensity(A)";        
    }    
    public Object Clone() {
        return new CellInternalIntensity();
    }    
}
