/*
 * MeasurementCollection.java
 *
 * Created on 06 October 2004, 14:06
 */

package neuroml.model.MeasurementTool;
import neuroml.sim.run.*;
/**
 *
 * @author  Jean-Alain Grunchec
 */
public class MeasurementCollection implements java.io.Serializable {
    protected MeasurementTool[] MeasurementList;
    protected short DestPortId;
    /** Creates a new instance of MeasurementCollection */
     public MeasurementCollection(MeasurementTool[] MeasurementList,short DestPortId) {
        this.DestPortId=DestPortId;
        this.MeasurementList=MeasurementList;
    }
    public double[] Measure(RunnableCell o, double t){
        double Array[]=new double[MeasurementList.length];
        for(int i=0;i<Array.length;i++){
            Array[i]=MeasurementList[i].getValue(o,t);
        }
        return Array;
    }
}
