package neuroml.model.MeasurementTool;

import neuroml.core.*;

/** Top level class for channels.
 * @author Fred Howell, Robert Cannon
 * @date March 2001
 */
public class MeasurementToolPkg extends Pkg {
    
    /** A list of classes defined here
     * Used by the Namespace
     * @see neuroml.util.Namespace
     */
    public static String[] getClassList() { 
	String[] ret = {
	    "CellExternalIntensity",
	    "CellIntensity",
	    "CellInternalIntensity",
            "CellVoltage",
            "MeasurementCollection",
            "MeasurementCollectionCellLevel",
            "MeasurementMethod",
            "MeasurementTool",
            "ModuleMeasurement",
            "ChannelIntensityMeasurement",
            "Channel_h_measurement",
            "Channel_mORn_measurement",
            "MeasurementSet"
	};
	return ret;
    }
}
