package neuroml.model.cell;

import neuroml.core.*;
import neuroml.model.channel.*;

/** A Neuron coded in a module
 */
public class ModuleNeuron  extends AbstractNeuron {
    public ModuleRef module;
    
    public ModuleNeuron() {
	super();
        //JAG
        module = new ModuleRef();
	//module = new ModuleRef("NeuronModule");
        module.setName(getClass().getName()+".module");
    }

    public ModuleNeuron(String name) { 
	super(name);
	module = new ModuleRef();//JAG
        module.setName(getClass().getName()+".module");
    }
}

