package neuroml.model.cell;

import neuroml.core.*;
import neuroml.model.channel.*;

/** The top level tree structure of a CableNeuron<p>
 *  Has a set of substructures.
 */
public class NeuronStructure extends NamedObject {
    
    public DValue length = new DValue(1.0,"um");
    public DValue diam   = new DValue(1.0,"um");
    public Set substructures = new Set("OrientedSubstructure");

    public NeuronStructure() {
	super("");
    }

    public NeuronStructure(String name) { 
	super(name);
    }

}
