package neuroml.model.channel;

import neuroml.core.*;

public class HHChannel extends Channel {

    public Ref permeantSpecie = new Ref("Specie");
    public DValue Erev = new DValue();
    public DValue Gmax = new DValue();
    public Set gates = new Set("HHGate");
    public String ivlaw= "ohmic";



    public HHChannel() {
    }

    public HHChannel(String name) {
	super(name);
    }

}
