package neuroml.model.network;
 
import neuroml.core.*;
 
/** Specification os a probe attachment
 *
 */
public class Attachment extends Connector {
    public PermanentSet MeasurementList =new PermanentSet("MeasurementTool");
    public Attachment() {
        this("","");
    }
    public Attachment(String name) {this(name,""); }
     
    public Attachment(String name, String source) 
    {
/*        super(name); 
        
        source=new Ref("RealPopulation");*/
        super(name); 
        this.source = new TreeRef("RealPopulation");//ElementRef->Ref->TreeRef  
        ((TreeRef)(this.source)).addLeaf("RealPopulation");
        ((TreeRef)(this.source)).addNode("SubNetwork");        
        dest = new Ref("Probe");
	(this.source).setTargetName(source);
        
    }
}