package neuroml.model.network;

import neuroml.core.*;

/** 
 * An indexed dimension
 */
public class IndexedDimension extends NamedObject {

    /** Size of this dimension - index values vary from <tt>0->size-1</tt>
     */
    public int size;
    public IndexedDimension() {}
    public IndexedDimension(String name) {super(name); }
    public IndexedDimension(String name, int size) {
	super(name); 
	this.size = size;
    }
}
