package neuroml.model.network;

import neuroml.core.*;

/** A specification of a population of objects - consists of 
 * a structure and an element class
 */
public class Population extends ElementRef {

    /** The population structure - provides the indexing scheme
     */
//JAG see RealPopulation    public PopulationStructure structure = new Grid1DStructure("structure",1);

    public Population() {}
    public Population(String name) {
	super(name); 
    }

    /** Useful constructors:
     */
    public Population(String name, String elementClass) {
	super(name, elementClass); 
    }
    public Population(String name, String elementClass, int size) {
	super(name,elementClass); 
//JAG see RealPopulation	structure = new Grid1DStructure("structure",size);
    }
 //JAG see RealPopulation
/*    
    public void setPopulationStructure(PopulationStructure struct) {
	structure = struct;
    }*/
}
