package neuroml.model.network;

import neuroml.core.*;

/** A projection specified as a list of connections
 */
public class RawProjection extends Projection {

    /** The connections to make
     */
    public List connections = new List("Connection");

    public RawProjection() {}
    public RawProjection(String name) {super(name); }
    public void copy(Connector pr){
         RawProjection prt=(RawProjection)pr;
         int size=prt.connections.size();
         for(int i=0;i<size;i++){
             connections.add(prt.connections.elementAt(i));
         }
    }   

}
