package neuroml.sim.state;


/** Interface to access the state of a cell or population instance
 * At the top level, there is just an id.
 */
public interface ElementState {  

    /** Set the global id of this element
     * @param id the globale id
     */
    public void setID(int id);

    /** Return the global id of this element
     * @return the global id
     */
    public int getID(); 
    
    
}
