package neuroml.util;


import java.io.*;
/**
 * An interface for producing an input stream on demand
 *
 * A null means that the resource is not (or no longer) available.
 * So, a one-shot producer may provide a value the first time but not
 * after that.
 */

public interface InputStreamProducer {
    InputStream getInputStream();
}
