package neuroml.util.schema;

import neuroml.core.*; 
import neuroml.util.*; 

/** 
 * NeuromlSchema version of an "Object"
 */
public class NeuromlObject {
    public String neuromlClass="";
    public String neuromlSchema=""; // Optional schema
    String name=""; // Optional name
    String path=""; // Optional path - do it as parent links instead?
    public java.util.List fieldValues = new java.util.Vector();
    public void setNeuromlClass( NeuromlClass nc ) {
	if (nc!=null)
	    neuromlClass = nc.getName(); 
    }
    public String getName() { return name; }
    public void setName(String n) { name = n; }
    public String getPath() { return path; }
    public void setPath(String n) { path = n; }
}

